<?php

namespace Drupal\entity_workflow_workspace\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\Core\Routing\RoutingEvents;
use Symfony\Component\Routing\RouteCollection;

/**
 * Subscriber for entity_workflow_workspace routes.
 *
 * @internal
 *   Tagged services are internal.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection): void {
    // Disallow access the generic 'Publish' and 'Revert' routes, these actions
    // are done with workflow transitions.
    if ($route = $collection->get('entity.workspace.publish_form')) {
      $route->addRequirements(['_access' => 'FALSE']);
    }
    if ($route = $collection->get('entity.workspace.revert_form')) {
      $route->addRequirements(['_access' => 'FALSE']);
    }
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    $events = parent::getSubscribedEvents();
    // Run after \Drupal\workspaces_ui\Routing\RouteSubscriber.
    $events[RoutingEvents::ALTER] = ['onAlterRoutes', -100];
    return $events;
  }

}
