<?php

namespace Drupal\entity_workflow\Form;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Form\FormInterface;
use Drupal\entity_workflow\EntityWorkflowTransition;

/**
 * Defines an interface for entity workflow forms.
 */
interface EntityWorkflowFormInterface extends FormInterface {

  /**
   * Gets the entity on which the transition will be applied.
   */
  public function getEntity(): EntityInterface;

  /**
   * Gets the transition that will be applied.
   *
   * Note that the transition might only be available during form validation and
   * submission, after it has been selected in the initial form.
   */
  public function getTransition(): ?EntityWorkflowTransition;

}
